# # #
# /37/euler-023.rb
# (c) 2010 Jan Lelis <mail@janlelis.de>. MIT License.
# See: https://rbjl.janlelis.com/37-project-euler-19-20-21-22-23-24-25-ruby
# # #

# https://projecteuler.net/index.php?section=problems&id=23
#  all numbers under 28123 that cannot be written as "abundant" number

require 'mathn'
require 'set'

MAX = 28123

class Integer
  def dsum # calculate divisor sum
    return 1 if self < 2

    pd = prime_division.flat_map{ |n,p| [n]*p } # get all prime divisors

    Set[ 1, *(1...pd.size).flat_map{ |e|
      # get all possible prime divisor combinations
      pd.combination(e).map{ |f| f.reduce(:*) }
    }].reduce(:+) # sum up
  end
end

can_be_written    = Set.new
cannot_be_written = (1..MAX).to_set
abundants         = (1..MAX).select{ |n| n.dsum > n }

abundants[0..MAX/2].each.with_index{ |x,i|
  abundants[i..-1].each{ |y|
    break if MAX < a = x + y
    can_be_written << a
  }
}

puts (cannot_be_written - can_be_written).reduce(:+)
